package cz.muni.fi.pb162.encyclopedia;

import java.util.*;

/**
 * TO DO: zvirata patrici danemu druhu
 * TO DO: usporadanou mnozinu zvirat
 * TO DO: "externi" komparator
 */
public class Encyclopedia
{
    private Map<Species,Set<Animal>> speciesAnimals = new HashMap<Species,Set<Animal>>();
    
    /**
     * @param species Zivocisny druh 
     * @return Usporadana mnozina zvirat daneho zivocisneho druhu
     */
    public Set<Animal> getAnimals(Species species) {
        return Collections.unmodifiableSortedSet(speciesAnimals.get(species));
    }
    
    public Collection<Species> getSpecies() {
        return Collections.unmodifiableCollection(speciesAnimals.keySet());
    }
    
    /**
     * Priradi zvirada k zivocisnemu druhu.
     * 
     * @param species Zivocisny druh
     * @param animals Seznam zvirat daneho druhu
     * @throws NullPointerException("species") pokud je 'species' null
     */
    public void assign(Species species, Animal... animals) {
        if (species == null) {
            throw new NullPointerException("species");
        }
        
        if (!speciesAnimals.containsKey(species)) {
            speciesAnimals.put(species, new TreeSet<Animal>());
        }

        for (Animal animal: animals) {
            if (animal == null) continue;
            speciesAnimals.get(species).add(animal);
        }
    }
}

